program Numerical_Integration;
uses crt;
const a=0.00;
      b=2.00;
      eps=0.01;
type IntegrationMethod=function(arg1:word;arg2:real):real;

function MyFunction (x:real):real;    { f(x) }
begin
   MyFunction:=-1.372+15.069*x-7.7*sqr(x)+x*sqr(x);
end;

function BarsMethod(n:word;h:real):real;far;
var i:word;
    s:real;
begin
   s:=0;
   for i:=0 to (n-1) do
      s:=s+MyFunction(a+i*h+h/2);
   BarsMethod:=s*h;
end;

function TrapeciaMethod(n:word;h:real):real;far;
var i:word;
    s:real;
begin
   s:=(MyFunction(a)+MyFunction(b))/2;
   for i:=1 to (n-1) do
      s:=s+MyFunction(a+i*h);
   TrapeciaMethod:=s*h;
end;

function SimpsonsMethod(n:word;h:real):real;far;
var i:word;
    s:real;
begin
   s:=0;
   for i:=1 to (n div 2) do
      s:=s+MyFunction(a+2*(i-1)*h)+4*MyFunction(a+(2*i-1)*h)+MyFunction(a+2*i*h);
   SimpsonsMethod:=s*h/3;
end;

procedure RunMethod(Method:IntegrationMethod;MethodName:string);
var nd:word;  { Number of divisions of <otrezok> }
    s1,s2,hc:real;  { S1,S2,current step }
    ni:byte;  { Number of iteration }
begin
   clrscr;
   WriteLn('᫥ ⥣஢ 㭪樨 ⮤ ',MethodName);
   WriteLn(' १ [',a:5:2,';',b:5:2,'].');
   WriteLn('Ŀ');
   WriteLn(' N  n   h      S  ');
   WriteLn('Ĵ');
   ni:=0;
   nd:=5;
   hc:=(b-a)/nd;
   s2:=Method(nd,hc);
   WriteLn('',ni:3,'',nd:3,'',hc:6:2,'',s2:6:2,'');
   repeat
      s1:=s2;
      nd:=2*nd;
      inc(ni);
      hc:=(b-a)/nd;
      s2:=Method(nd,hc);
      WriteLn('',ni:3,'',nd:3,'',hc:6:2,'',s2:6:2,'');
   until abs(s2-s1)<=eps;
   WriteLn('');
   WriteLn(' 祭. ⥫ १ S=',s2:6:2,'.');
   readln;
end;

begin
   RunMethod(BarsMethod,'אַ㣮쭨  ।');
   RunMethod(TrapeciaMethod,'࠯権');
   RunMethod(SimpsonsMethod,'ᮭ');
end.